<template>
  <v-menu v-model="parentMenu" :close-on-content-click="false">
    <template #activator="{ props, isActive }">
      <!-- Filter chip (which activates the menu) -->
      <div
        v-bind="props"
        class="flex justify-center h-fit items-center gap-2 pl-4 pr-2 py-[6px] border rounded-[8px] cursor-pointer max-w-full sm:max-w-[300px]"
        :class="
          selectedFilterAnswerData?.length
            ? 'border-0 bg-primary'
            : 'border-[#767680] border-opacity-100'
        "
      >
        <!-- Filter chip main content -->
        <div class="flex items-center gap-2">
          <!-- Filter Chip Check Icon when selected -->
          <div v-if="selectedFilterAnswerData?.length">
            <Icon
              height="18"
              width="18"
              icon="mingcute:check-line"
              class="text-onPrimary"
            />
          </div>

          <!-- Filter Chip title -->
          <svn-pro-text
            body-medium
            medium
            :color="
              selectedFilterAnswerData?.length ? 'surface' : 'onSurfaceVariant'
            "
          >
            {{ formattedTitle }}
          </svn-pro-text>

          <!-- Filter Chip Operator Option & Answer -->
          <div
            v-if="selectedFilterAnswerData?.length"
            class="flex items-center gap-1"
          >
            <!-- Filter Chip Selected Operator Option -->
            <svn-pro-text
              v-if="type === FilterType.NUMBER || type === FilterType.DATE"
              medium
              body-medium
              color="surface"
              class="max-w-[115px] line-clamp-1 break-all"
            >
              {{ getSelectItemText(filterOperatorOption) }}
            </svn-pro-text>

            <!-- Filter Chip Selected Answer(s) (Type multi_select) -->
            <svn-pro-text
              v-if="type === FilterType.MULTI_SELECT"
              medium
              body-medium
              color="surface"
              class="max-w-[115px] line-clamp-1 break-all"
            >
              {{ getFilterAnswers() }}
            </svn-pro-text>

            <!-- Filter Chip Selected Answer(s) (Other types) -->
            <div v-else class="max-w-[115px]">
              <svn-pro-text
                medium
                body-medium
                color="surface"
                class="max-w-[115px] line-clamp-1 break-all"
              >
                {{ selectedFilterAnswerData }}
              </svn-pro-text>
            </div>
          </div>

          <!-- Filter up/down arrow -->
          <div>
            <Icon
              height="18"
              width="18"
              :icon="
                isActive ? 'mingcute:up-small-fill' : 'mingcute:down-small-fill'
              "
              :class="
                selectedFilterAnswerData?.length
                  ? 'text-onPrimary'
                  : 'text-onSurface'
              "
            />
          </div>
        </div>
      </div>
    </template>

    <!-- Filter chip menu (after the chip is pressed) -->
    <v-list class="!py-0">
      <div
        class="flex flex-col p-4 items-start gap-2 w-full min-w-[227px] max-w-[500px]"
      >
        <div
          v-if="type !== FilterType.TEXT && type !== FilterType.MULTI_SELECT"
          class="w-full justify-between flex items-center"
        >
          <div class="w-full flex items-center gap-4">
            <!-- Filter chip selected operator option (Other types) -->
            <v-menu v-model="childMenu" :close-on-content-click="false">
              <template #activator="{ props, isActive }">
                <!-- Menu activator to select another filter operator option -->
                <div
                  v-bind="props"
                  id="activatorMenu"
                  class="flex justify-center items-center gap-2 pl-4 pr-2 py-[6px] border border-[#767680] border-opacity-100 rounded-[8px] cursor-pointer max-w-full"
                >
                  <!-- Filter Chip selected operator option -->
                  <svn-pro-text body-medium medium color="onSurfaceVariant">
                    {{ getSelectItemText(filterOperatorOption) }}
                  </svn-pro-text>

                  <!-- Down arrow after filter operator option -->
                  <div>
                    <Icon
                      height="18"
                      width="18"
                      icon="mingcute:down-small-fill"
                      class="text-onSurface"
                    />
                  </div>
                </div>
              </template>

              <!-- Filter operator option list -->
              <v-list class="!py-0" color="primary">
                <v-list-item
                  v-for="(element, index) in operatorOptions"
                  :key="index"
                  :value="index"
                  :active="false"
                  class="min-w-[167px]"
                  @click="changeSelectItemModel(element)"
                >
                  <!-- Filter operator option value -->
                  <svn-pro-text body-large class="line-clamp-1">
                    {{ getSelectItemText(element) }}
                  </svn-pro-text>
                </v-list-item>
              </v-list>
            </v-menu>
          </div>
        </div>

        <!-- Filter type="text" OR Filter type="number" -->
        <svn-pro-text-field
          v-if="type === FilterType.TEXT || type === FilterType.NUMBER"
          v-model="selectedFilterAnswerData"
          :autofocus="false"
          :label="title"
          hide-details
          clearable
          clear-icon="mdi-close"
          class="w-full"
          :type="type"
          variant="outlined"
          @update:model-value="updateSelectedFilterAnswerData"
          @click:clear="clearFilterNoEmit"
        />

        <!-- Filter type="date" -->
        <svn-pro-edit-date
          v-else-if="type === FilterType.DATE"
          @save="updateDate"
        >
          <template #activator="{ props }">
            <svn-pro-text-field
              v-bind="props"
              v-model="selectedFilterAnswerData"
              variant="outlined"
              clearable
              clear-icon="mdi-close"
              color="primary"
              class="w-full"
              append-inner-icon="custom:mingcute:calendar-2-line"
              label="Date"
              @click:clear="clearFilterNoEmit"
            />
          </template>
        </svn-pro-edit-date>

        <!-- Filter type="multi_select" -->
        <svn-pro-autocomplete
          v-else-if="type === FilterType.MULTI_SELECT"
          v-model="selectedFilterAnswerData"
          v-model:search="searchText"
          :autofocus="false"
          variant="outlined"
          :multiple="true"
          clearable
          clear-icon="mdi-close"
          class="w-full max-w-[195px]"
          :menu-props="{ maxWidth: 195, maxHeight: 300 }"
          :item-title="(item) => getItemDisplayValue(item)"
          :items="items"
          :return-object="true"
          :label="title"
          @input="setSearch"
          @intersect="onIntersect"
          @update:model-value="
            updateSelectedFilterAnswerData(FilterType.MULTI_SELECT, $event)
          "
          @click:clear="clearFilterNoEmit"
        />
      </div>
    </v-list>
  </v-menu>
</template>

<script setup>
import { ref, onMounted, watch, computed } from 'vue';
import moment from 'moment';
import { Icon } from '@iconify/vue';
import { debounce } from 'lodash';
import SvnProText from '../styles/SvnProText.vue';
import SvnProTextField from '../input/SvnProTextField.vue';
import SvnProEditDate from '@/components/dialog/SvnProEditDate.vue';
import SvnProAutocomplete from '@/components/input/SvnProAutocomplete.vue';
import {
  FilterType,
  FilterOperatorOptions,
  FilterAutocompleteProperties,
} from '../../constants/types';

const props = defineProps({
  title: { type: String, default: '' },
  type: {
    type: String,
    default: '',
    validator: (value) => Object.values(FilterType).includes(value),
  },
  operatorOptions: {
    type: Array,
    default: () => {},
    validator: (value) =>
      Array.isArray(value) &&
      value.every((item) =>
        Object.values(FilterOperatorOptions).includes(item)
      ),
  },
  items: { type: Array, default: () => [] },
});

onMounted(async () => {
  initializeFilterOperator();
});

const emit = defineEmits([
  'update-selected-data-filters',
  'set-data-after-search',
  'load-more-data',
]);

const searchText = ref(null);
const filterOperatorOption = ref(null);
const selectedFilterAnswerData = ref(null);
const parentMenu = ref(false);
const childMenu = ref(false);

const formattedTitle = computed(() =>
  selectedFilterAnswerData?.value?.length ? `${props.title}:` : props.title
);

const getSelectItemText = (key) => {
  return key
    .replaceAll('_', ' ') // Replace underscores with spaces
    .replace(/(^|\s)\S/g, (char) => char.toUpperCase()); // Capitalize first letter after space
};

const onIntersect = () => {
  emit('load-more-data');
};
const changeSelectItemModel = (value) => {
  filterOperatorOption.value = value;
  document.getElementById('activatorMenu').click();
  updateSelectedFilterAnswerData();
};

// Initializes the filter operator option by setting it to the first available option from props.
const initializeFilterOperator = () => {
  if (FilterType.DATE === props.type || FilterType.NUMBER === props.type) {
    filterOperatorOption.value = props?.operatorOptions?.[0];
  }
};

const updateSelectedFilterAnswerData = (type, event) => {
  // Check if the filter type is 'multi_select'
  if (type === FilterType.MULTI_SELECT) {
    // If the event is an object (e.g., an array of selected items)
    if (
      event.every(
        (item) =>
          typeof item === 'object' && item !== null && !Array.isArray(item)
      )
    ) {
      // Emit the updated filter data as an array of IDs
      emit('update-selected-data-filters', {
        value: event.map((e) => e.id), // Map the event array to extract IDs
        operator: filterOperatorOption?.value, // Include the current operator
      });
    } else {
      // Emit the updated filter data directly if the event is not an object
      emit('update-selected-data-filters', {
        value: event,
        operator: filterOperatorOption?.value,
      });
    }
  } else {
    // For non-'multi_select' types, emit the current filter answer data
    emit('update-selected-data-filters', {
      value: selectedFilterAnswerData.value, // Use the existing selected filter data
      operator: filterOperatorOption?.value, // Include the current operator
    });
  }
};

const getFilterAnswers = () => {
  let data = ''; // Initialize an empty string to hold the formatted data

  // Iterate over the selected filter answer data
  selectedFilterAnswerData.value.map((element, i) => {
    // Get the display value using getItemDisplayValue
    const displayValue = getItemDisplayValue(element);

    // Append the value to the data string
    data +=
      i !== selectedFilterAnswerData.value.length - 1
        ? `${displayValue}, `
        : displayValue;
  });

  // Return the formatted string
  return data;
};

const setSearch = debounce(() => {
  emit('set-data-after-search', searchText.value);
}, 300);

const updateDate = (value) => {
  // Format the input date to 'DD-MM-YYYY' format using moment.js
  selectedFilterAnswerData.value = moment(value).format('DD-MM-YYYY');

  // Call the 'updateSelectedFilterAnswerData' method to update the filter data with the formatted date
  updateSelectedFilterAnswerData();
};

watch(
  () => props?.data,
  (newValue) => {
    if (newValue) {
      initializeFilterOperator();
    }
  }
);

const clearFilterNoEmit = () => {
  // Clear the selected filter answer data by setting it to null
  selectedFilterAnswerData.value = null;

  // Emit the cleared filter data with the current operator (without triggering further updates)
  emit('update-selected-data-filters', {
    value: selectedFilterAnswerData.value,
    operator: filterOperatorOption?.value,
  });
};

function getItemDisplayValue(item) {
  // Handle null or undefined items
  if (item == null) {
    return ''; // Return an empty string or a fallback value
  }

  // Handle non-object types (e.g., strings, numbers)
  if (typeof item !== 'object') {
    return item; // Return the item itself
  }

  // Define the priority order of properties to check
  const properties = Object.values(FilterAutocompleteProperties);

  // Use optional chaining and logical OR to find the first matching property
  const displayValue = properties.find((prop) => item[prop] != null);

  // Return the value of the first matching property, or a fallback value if none is found
  return displayValue ? item[displayValue] : '';
}
</script>
